package ch.hepia.scala

/* Implémentez les fonctions suivantes. Vous ne pouvez utiliser que les
 *  méthode de 'List' vues dans les exercices précédents.
 */
object HKFunc {

  /* La fonction 'map' applique une fonction 'f' sur chaque élément de
   * la liste 'as'.  La liste résultat doit avoir la même longueur que
   * l'argument.
   */
  def map[A,B]( as: List[A] )( f: A=>B ): List[B] = {
    @scala.annotation.tailrec
    def applyOnHead(rec: List[A], acc: List[B]): List[B] = rec match {
      case Nil => acc
      case a :: tail => applyOnHead(tail, f(a)::acc)
    }
    Serie3.rev(applyOnHead(as, List.empty))
  }

  /* La fonction 'filter' utilise le prédicat 'f' pour déterminer quel
   * élément garder. Le résultat peut être vide, mais l'ordre doit
   * être préservé.
bbb   */
  def filter[A]( as: List[A] )( f: A=>Boolean ): List[A] = {
    @scala.annotation.tailrec
    def applyOnHead(rec: List[A], acc: List[A]): List[A] = rec match {
      case Nil => acc
      case a :: tail if f(a) => applyOnHead(tail, a::acc)
      case a :: tail if !f(a) => applyOnHead(tail, acc)
    }
    Serie3.rev(applyOnHead(as, List.empty))
  }

  /* Réduit une liste 'as' en utilisant une opération binaire 'f'.  On
   * supposera que 'as' n'est pas vide.
   */
  def reduce[A]( as: List[A] )( f: (A,A)=>A ): A = {
    @scala.annotation.tailrec
    def reduce2Head(rec: List[A], acc: A): A = rec match{
      case Nil => acc
      case b :: tail => reduce2Head(tail, f(b, acc))
    }
    reduce2Head(as.tail, as.head)
  }





  /* Transforme une fonction 'f' en une fonction s'appliquant sur une
  *  liste. Utiliser la fonction 'map' définie ci-dessus
  */
  def lift[A,B]( f: A=>B ): List[A]=>List[B] = { (lstA: List[A]) => map(lstA)(f) }

  /* DIFFICILE. Transforme une liste 'as' au moyen de la fonction 'f'.
   * Cette fonction est appliquée à chaque élément de 'as' pour
   * produire une nouvelle liste (qui peut être vide). Le résultat est
   * la concaténation de chaque nouvelle liste en respectant l'ordre.
   */
  def bind[A,B]( as: List[A] )( f: A=>List[B] ): List[B] = {
    Serie3.flat(map(as)(f))
  }

}
